class SocketType {
  // Chat
  static const String MSG_READ = "MSG_READ";
  static const String NEW_MSG = "NEW_MSG";
  static const String MSG_DELETE = "MSG_DELETE";
  static const String NEW_CHAT = "NEW_CHAT";
  static const String GROUP_INFO_CHANGED = "GROUP_INFO_CHANGED";
  static const String CLEAR_CHAT = "CLEAR_CHAT";
}

class SocketData {
  final String type;
  final dynamic data;

  SocketData(this.type, this.data);

  SocketData.named({this.type, this.data});
}

abstract class SocketEvent {
  final String channelId;

  SocketEvent(this.channelId);
}

class SocketJoinEvent extends SocketEvent {
  final String userId;
  SocketJoinEvent(String channelId, this.userId) : super(channelId);
}

class SocketLeaveEvent extends SocketEvent {
  final String userId;
  SocketLeaveEvent(String channelId, this.userId) : super(channelId);
}

class SocketSubscribeEvent extends SocketEvent {
  SocketSubscribeEvent(String channelId) : super(channelId);
}

class SocketUnsubscribeEvent extends SocketEvent {
  SocketUnsubscribeEvent(String channelId) : super(channelId);
}

class SocketErrorEvent extends SocketEvent {
  final String error;

  SocketErrorEvent(String channelId, this.error) : super(channelId);
}

// @JsonSerializable(explicitToJson: true)
// class SocketMessageData extends SocketChatData {
//   final Message message;

//   SocketMessageData(this.message, String type) : super(type);

//   SocketMessageData.named({this.message, String type}) : super(type);

//   factory SocketMessageData.fromJson(json) => _$SocketMessageDataFromJson(json);

//   Map<String, dynamic> toJson() => _$SocketMessageDataToJson(this);

//   SocketMessageData copyWith({Message message}) {
//     return SocketMessageData.named(message: message ?? this.message);
//   }
// }

// @JsonSerializable(explicitToJson: true)
// class SocketReadData extends SocketChatData {
//   @JsonKey(name: "chat_id")
//   final String chatId;
//   @JsonKey(name: "msg_id")
//   final String msgId;

//   SocketReadData(this.chatId, this.msgId, String type) : super(type);

//   SocketReadData.named({this.chatId, this.msgId, String type}) : super(type);

//   factory SocketReadData.fromJson(json) => _$SocketReadDataFromJson(json);

//   Map<String, dynamic> toJson() => _$SocketReadDataToJson(this);
// }

// @JsonSerializable(explicitToJson: true)
// class SocketMsgDeleteData extends SocketChatData {
//   @JsonKey(name: "chat_id")
//   final String chatId;
//   @JsonKey(name: "msg_id")
//   final String msgId;
//   @JsonKey(name: "user_id")
//   final String userId;

//   SocketMsgDeleteData(this.chatId, this.msgId, this.userId)
//       : super(SocketType.MSG_DELETE);

//   Map<String, dynamic> toJson() => _$SocketMsgDeleteDataToJson(this);

//   factory SocketMsgDeleteData.fromJson(json) =>
//       _$SocketMsgDeleteDataFromJson(json);
// }

// @JsonSerializable(explicitToJson: true)
// class SocketNewChatData extends SocketChatData {
//   @JsonKey(name: "chat_id")
//   final String chatId;

//   SocketNewChatData(
//     this.chatId,
//   ) : super(SocketType.NEW_CHAT);

//   Map<String, dynamic> toJson() => _$SocketNewChatDataToJson(this);

//   factory SocketNewChatData.fromJson(json) => _$SocketNewChatDataFromJson(json);
// }

// @JsonSerializable(explicitToJson: true)
// class SocketGroupInfoChanged extends SocketChatData {
//   @JsonKey(name: "chat_id")
//   final String chatId;

//   SocketGroupInfoChanged(
//     this.chatId,
//   ) : super(SocketType.GROUP_INFO_CHANGED);

//   Map<String, dynamic> toJson() => _$SocketGroupInfoChangedToJson(this);

//   factory SocketGroupInfoChanged.fromJson(json) =>
//       _$SocketGroupInfoChangedFromJson(json);
// }

// @JsonSerializable(explicitToJson: true)
// class SocketClearData extends SocketChatData {
//   @JsonKey(name: "chat_id")
//   final String chatId;

//   SocketClearData(this.chatId, String type) : super(type);

//   Map<String, dynamic> toJson() => _$SocketClearDataToJson(this);

//   factory SocketClearData.fromJson(json) => _$SocketClearDataFromJson(json);
// }
